package net.jasonshepherd.example;

import java.io.IOException;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.myapp.ejb.Greeter;

/**
 * Servlet implementation class EJBClient
 */
public class EJBClient extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public EJBClient() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		/*JBoss AS 5
		final String jndiName = "myapp/Greeter/remote";
		Object obj = null;
		try {
			Context ic = new InitialContext();
			obj = ic.lookup(jndiName);
		} catch (NamingException e) {
			throw new IllegalStateException("Could not lookup EJB", e);
		}
		GreeterRemote greeter = (GreeterRemote) obj;
		String result = greeter.toString() + "returned: " + greeter.greet("Jason");
		response.getWriter().append(result);*/
        try {
            final Hashtable props = new Hashtable();
            // setup the ejb: namespace URL factory
            props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
            // create the InitialContext
            final Context context = new javax.naming.InitialContext(props);
 
            // Lookup the Greeter bean using the ejb: namespace syntax which is explained here https://docs.jboss.org/author/display/AS71/EJB+invocations+from+a+remote+client+using+JNDI
            String jndiName = "ejb:" + "myapp" + "/" + "myejb" + "/" + "" + "/" + "GreeterBean" + "!" + org.myapp.ejb.Greeter.class.getName();
            
            System.out.println("Looking for ejb with jndiName: " + jndiName);
            
			final Greeter bean = (Greeter) context.lookup(jndiName);
 
            // invoke on the bean
            final String greeting = bean.greet("Tom");
 
            response.getWriter().append("Received greeting: " + greeting);
 
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
	}

}
